using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_MobileData
    /// </summary>
    public partial class T_Sys_MobileData
    {
        public T_Sys_MobileData()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_MobileNum)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_MobileData");
            strSql.Append(" where F_MobileNum=@F_MobileNum ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MobileNum", SqlDbType.VarChar,20)          };
            parameters[0].Value = F_MobileNum;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(Model.T_Sys_MobileData model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_MobileData(");
            strSql.Append("F_MobileNum,F_ZipCode,F_CityDes,F_CardDes)");
            strSql.Append(" values (");
            strSql.Append("@F_MobileNum,@F_ZipCode,@F_CityDes,@F_CardDes)");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MobileNum", SqlDbType.VarChar,20),
                    new SqlParameter("@F_ZipCode", SqlDbType.VarChar,10),
                    new SqlParameter("@F_CityDes", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CardDes", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_MobileNum;
            parameters[1].Value = model.F_ZipCode;
            parameters[2].Value = model.F_CityDes;
            parameters[3].Value = model.F_CardDes;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_MobileData model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_MobileData set ");
            strSql.Append("F_ZipCode=@F_ZipCode,");
            strSql.Append("F_CityDes=@F_CityDes,");
            strSql.Append("F_CardDes=@F_CardDes");
            //strSql.Append("Province=@Province,");
            //strSql.Append("City=@City");
            strSql.Append(" where F_MobileNum=@F_MobileNum ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ZipCode", SqlDbType.VarChar,10),
                    new SqlParameter("@F_CityDes", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CardDes", SqlDbType.VarChar,50),
                    new SqlParameter("@F_MobileNum", SqlDbType.VarChar,20)
                    //new SqlParameter("@Province", SqlDbType.VarChar,20),
                    //new SqlParameter("@City", SqlDbType.VarChar,20)

        };
            parameters[0].Value = model.F_ZipCode;
            parameters[1].Value = model.F_CityDes;
            parameters[2].Value = model.F_CardDes;
            parameters[3].Value = model.F_MobileNum;
            //parameters[4].Value = model.Province;
            //parameters[5].Value = model.City;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(string F_MobileNum)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_MobileData ");
            strSql.Append(" where F_MobileNum=@F_MobileNum ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MobileNum", SqlDbType.VarChar,20)          };
            parameters[0].Value = F_MobileNum;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_MobileNumlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_MobileData ");
            strSql.Append(" where F_MobileNum in (" + F_MobileNumlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_MobileData GetModel(string F_MobileNum)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_MobileNum,F_ZipCode,F_CityDes,F_CardDes from T_Sys_MobileData ");
            strSql.Append(" where F_MobileNum=@F_MobileNum ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MobileNum", SqlDbType.VarChar,20)          };
            parameters[0].Value = F_MobileNum;

            Model.T_Sys_MobileData model = new Model.T_Sys_MobileData();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_MobileData DataRowToModel(DataRow row)
        {
            Model.T_Sys_MobileData model = new Model.T_Sys_MobileData();
            if (row != null)
            {
                if (row["F_MobileNum"] != null)
                {
                    model.F_MobileNum = row["F_MobileNum"].ToString();
                }
                if (row["F_ZipCode"] != null)
                {
                    model.F_ZipCode = row["F_ZipCode"].ToString();
                }
                if (row["F_CityDes"] != null)
                {
                    model.F_CityDes = row["F_CityDes"].ToString();
                }
                if (row["F_CardDes"] != null)
                {
                    model.F_CardDes = row["F_CardDes"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  F_MobileNum,F_ZipCode,F_CityDes,F_CardDes ");
            strSql.Append(" FROM T_Sys_MobileData where Province is null");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_MobileNum,F_ZipCode,F_CityDes,F_CardDes ");
            strSql.Append(" FROM T_Sys_MobileData ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_MobileData ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_MobileNum desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_MobileData T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }



        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
